clear
clc

num = {[1];  [-1,1]; [1];    [1];      [1];   [1]      ; [1];   [-1]  ;[1]     ;[1]     ;[1]    }; % numerator matrix of all the transfer funtions in Exercise 4.2
den = {[1,1];[1,1];  [-1,1]; [1,0,-1]; [1,0]; [1,0,0,0]; [1,1]; [1,1] ;[1,1,1] ;[1,0,1] ;[1,1,0]}; % denominator matrix of all the transfer funtions in Exercise 4.2

[m,n] = size(num); % determine number of transfer funtions

Calculated_Poles = {}; %empty cell to store poles of transfer functions

for i= 1:m
    
    % determine transfer funtions of corresponding exercise
    if i~=7
        H = tf(num(i,:),den(i,:));
    else
        H = tf(num(i,:),den(i,:),'InputDelay',1); %exercise 7 has a time delay
    end
    
    Pole = pole(H);

    Calculated_Poles = [Calculated_Poles; {Pole}];
    %Calculated_Poles = sprintf('The pole for exercise %d is %d.', i, Pole)
    
    %plot
    figure(); hold on
    
    subplot(3,1,1)
    impulse(H)
    title(['Impulse response plot for exercise' num2str(i)]);
    
    subplot(3,1,2)
    step(H)
    title(['Step response plot for exercise' num2str(i)]);
    
    subplot(3,1,3)
    pzmap(H)
    title(['Zero pole plot for exercise' num2str(i)]);
    
    hold off
end